library aursir_polymer.listen;

import 'package:polymer/polymer.dart';
import 'dart:async';
import 'package:aursir4dart/imported_appkey.dart';

@CustomTag('aursir-polymer-listen')
class AursirListenElement extends PolymerElement {
  @published AurSirImport import;
  @published bool exported;
  @published bool onexported;

  @published String appkey;
  @published String appkey_yaml="";
  @published List<String> tags = [];

  @published String function="";
  @published List<String> functions;

  AursirListenElement.created(): super.created();
  attached() {

  }
  Future callFunction(String FunctionName, [Map Parameter]) => $['import'].callFunction(FunctionName,Parameter);
  void triggerFunction(String FunctionName, [Map Parameter]) => $['import'].triggerFunction(FunctionName,Parameter);

  void onimportready(){
    if (function != ""){
      _startlisten(function);
    } else {
      for (String fun in functions) {
        _startlisten(fun);
      }
    }
  }


  void onexportedchange() {fire("export-state-change");}

  void _startlisten(function) {
    asimport.listenToFunction(function).listen((result) => fire('update', detail:{"function":function,"result":result}));
  }
}
